var ohm = require('ohm-js');
module.exports = ohm.makeRecipe(["grammar",{"source":"ESQueryGrammar {\n    ESQuery = query\n\n    reservedWord = \"AND\" | \"OR\" | \"NOT\" | \"TO\"\n    boolOperator = \"AND\" | \"OR\"\n    orSpace = space+\n    orLine = \"|\"\n\n    // STRING LITERALS\n    sourceCharacter = any\n    nonEscapeCharacter = ~(singleEscapeCharacter) sourceCharacter\n    characterEscapeSequence = singleEscapeCharacter\n                            | nonEscapeCharacter\n    singleEscapeCharacter = \"\\\"\" | \"\\\\\"\n    doubleStringCharacter = ~(\"\\\"\" | \"\\\\\") sourceCharacter -- nonEscaped\n                          | \"\\\\\" characterEscapeSequence -- Escaped\n    singleESEscapeCharacter = \" \" | \"+\" | \"-\" | \"=\" | \"!\" | \"(\" | \")\" | \"{\" | \"}\"\n                            | \"[\" | \"]\" | \"^\" | \"\\\"\" | \"~\" | \"*\" | \"?\" | \":\" | \"\\\\\" | \"/\"\n    escapedESStringCharacter = \"\\\\\" singleESEscapeCharacter\n\twildcardCharacter = \"*\" | \"?\"\n    regexCharacter = \"*\" | \"?\" | \"[\" | \"]\" | \"(\" | \")\"\n\n    unquotedString = ~reservedWord (escapedESStringCharacter | wildcardCharacter | alnum | \"_\" | \".\" | \"-\" | \"’\")+\n    quotedString = \"\\\"\" doubleStringCharacter* \"\\\"\"\n\n    detachedCond = quotedString | unquotedString\n\n    // UTILS\n    spaced<x> = space+ x space+\n    parented<x> = \"(\" space* x space* \")\"\n\n    spacedBool = spaced<boolOperator>\n    genericBoolOp = spacedBool | orSpace | orLine\n\n    // FIELD QUERY\n    fieldName = ~reservedWord (alnum | \".\" | \"_\")+ &\":\"\n    fieldCond = fieldName \":\" subquery\n\n    // RANGE QUERY\n    rangeValue = ~space ((alnum | \"/\" | \"-\" | \":\" | \"+\")+ | \"*\")\n    rangeCond = \"[\" space* rangeValue spaced<\"TO\"> rangeValue space* \"]\"\n\n    // REGEX QUERY\n    regexCond = \"/\" (alnum | regexCharacter)+ \"/\"\n\n    // CONDITIONS\n    genericCond = fieldCond | rangeCond | regexCond | detachedCond\n    cond = parented<genericCond> | genericCond\n\n    simpleNegation = \"-\" subquery\n    simpleMust = \"+\" subquery\n    longNegation = \"NOT\" space+ subquery\n    markedCond = longNegation | simpleNegation | simpleMust\n\n    queryElement = markedCond | cond\n\tsubquery = parented<query> | queryElement\n    query = nonemptyListOf<subquery, genericBoolOp> | parented<query>\n}"},"ESQueryGrammar",null,"ESQuery",{"ESQuery":["define",{"sourceInterval":[21,36]},null,[],["app",{"sourceInterval":[31,36]},"query",[]]],"reservedWord":["define",{"sourceInterval":[42,84]},null,[],["alt",{"sourceInterval":[57,84]},["terminal",{"sourceInterval":[57,62]},"AND"],["terminal",{"sourceInterval":[65,69]},"OR"],["terminal",{"sourceInterval":[72,77]},"NOT"],["terminal",{"sourceInterval":[80,84]},"TO"]]],"boolOperator":["define",{"sourceInterval":[89,116]},null,[],["alt",{"sourceInterval":[104,116]},["terminal",{"sourceInterval":[104,109]},"AND"],["terminal",{"sourceInterval":[112,116]},"OR"]]],"orSpace":["define",{"sourceInterval":[121,137]},null,[],["plus",{"sourceInterval":[131,137]},["app",{"sourceInterval":[131,136]},"space",[]]]],"orLine":["define",{"sourceInterval":[142,154]},null,[],["terminal",{"sourceInterval":[151,154]},"|"]],"sourceCharacter":["define",{"sourceInterval":[183,204]},null,[],["app",{"sourceInterval":[201,204]},"any",[]]],"nonEscapeCharacter":["define",{"sourceInterval":[209,270]},null,[],["seq",{"sourceInterval":[230,270]},["not",{"sourceInterval":[230,254]},["app",{"sourceInterval":[232,253]},"singleEscapeCharacter",[]]],["app",{"sourceInterval":[255,270]},"sourceCharacter",[]]]],"characterEscapeSequence":["define",{"sourceInterval":[275,371]},null,[],["alt",{"sourceInterval":[301,371]},["app",{"sourceInterval":[301,322]},"singleEscapeCharacter",[]],["app",{"sourceInterval":[353,371]},"nonEscapeCharacter",[]]]],"singleEscapeCharacter":["define",{"sourceInterval":[376,411]},null,[],["alt",{"sourceInterval":[400,411]},["terminal",{"sourceInterval":[400,404]},"\""],["terminal",{"sourceInterval":[407,411]},"\\"]]],"doubleStringCharacter_nonEscaped":["define",{"sourceInterval":[440,484]},null,[],["seq",{"sourceInterval":[440,470]},["not",{"sourceInterval":[440,454]},["alt",{"sourceInterval":[442,453]},["terminal",{"sourceInterval":[442,446]},"\""],["terminal",{"sourceInterval":[449,453]},"\\"]]],["app",{"sourceInterval":[455,470]},"sourceCharacter",[]]]],"doubleStringCharacter_Escaped":["define",{"sourceInterval":[513,552]},null,[],["seq",{"sourceInterval":[513,541]},["terminal",{"sourceInterval":[513,517]},"\\"],["app",{"sourceInterval":[518,541]},"characterEscapeSequence",[]]]],"doubleStringCharacter":["define",{"sourceInterval":[416,552]},null,[],["alt",{"sourceInterval":[440,552]},["app",{"sourceInterval":[440,470]},"doubleStringCharacter_nonEscaped",[]],["app",{"sourceInterval":[513,541]},"doubleStringCharacter_Escaped",[]]]],"singleESEscapeCharacter":["define",{"sourceInterval":[557,724]},null,[],["alt",{"sourceInterval":[583,724]},["terminal",{"sourceInterval":[583,586]}," "],["terminal",{"sourceInterval":[589,592]},"+"],["terminal",{"sourceInterval":[595,598]},"-"],["terminal",{"sourceInterval":[601,604]},"="],["terminal",{"sourceInterval":[607,610]},"!"],["terminal",{"sourceInterval":[613,616]},"("],["terminal",{"sourceInterval":[619,622]},")"],["terminal",{"sourceInterval":[625,628]},"{"],["terminal",{"sourceInterval":[631,634]},"}"],["terminal",{"sourceInterval":[665,668]},"["],["terminal",{"sourceInterval":[671,674]},"]"],["terminal",{"sourceInterval":[677,680]},"^"],["terminal",{"sourceInterval":[683,687]},"\""],["terminal",{"sourceInterval":[690,693]},"~"],["terminal",{"sourceInterval":[696,699]},"*"],["terminal",{"sourceInterval":[702,705]},"?"],["terminal",{"sourceInterval":[708,711]},":"],["terminal",{"sourceInterval":[714,718]},"\\"],["terminal",{"sourceInterval":[721,724]},"/"]]],"escapedESStringCharacter":["define",{"sourceInterval":[729,784]},null,[],["seq",{"sourceInterval":[756,784]},["terminal",{"sourceInterval":[756,760]},"\\"],["app",{"sourceInterval":[761,784]},"singleESEscapeCharacter",[]]]],"wildcardCharacter":["define",{"sourceInterval":[786,815]},null,[],["alt",{"sourceInterval":[806,815]},["terminal",{"sourceInterval":[806,809]},"*"],["terminal",{"sourceInterval":[812,815]},"?"]]],"regexCharacter":["define",{"sourceInterval":[820,870]},null,[],["alt",{"sourceInterval":[837,870]},["terminal",{"sourceInterval":[837,840]},"*"],["terminal",{"sourceInterval":[843,846]},"?"],["terminal",{"sourceInterval":[849,852]},"["],["terminal",{"sourceInterval":[855,858]},"]"],["terminal",{"sourceInterval":[861,864]},"("],["terminal",{"sourceInterval":[867,870]},")"]]],"unquotedString":["define",{"sourceInterval":[876,986]},null,[],["seq",{"sourceInterval":[893,986]},["not",{"sourceInterval":[893,906]},["app",{"sourceInterval":[894,906]},"reservedWord",[]]],["plus",{"sourceInterval":[907,986]},["alt",{"sourceInterval":[908,984]},["app",{"sourceInterval":[908,932]},"escapedESStringCharacter",[]],["app",{"sourceInterval":[935,952]},"wildcardCharacter",[]],["app",{"sourceInterval":[955,960]},"alnum",[]],["terminal",{"sourceInterval":[963,966]},"_"],["terminal",{"sourceInterval":[969,972]},"."],["terminal",{"sourceInterval":[975,978]},"-"],["terminal",{"sourceInterval":[981,984]},"’"]]]]],"quotedString":["define",{"sourceInterval":[991,1038]},null,[],["seq",{"sourceInterval":[1006,1038]},["terminal",{"sourceInterval":[1006,1010]},"\""],["star",{"sourceInterval":[1011,1033]},["app",{"sourceInterval":[1011,1032]},"doubleStringCharacter",[]]],["terminal",{"sourceInterval":[1034,1038]},"\""]]],"detachedCond":["define",{"sourceInterval":[1044,1088]},null,[],["alt",{"sourceInterval":[1059,1088]},["app",{"sourceInterval":[1059,1071]},"quotedString",[]],["app",{"sourceInterval":[1074,1088]},"unquotedString",[]]]],"spaced":["define",{"sourceInterval":[1107,1134]},null,["x"],["seq",{"sourceInterval":[1119,1134]},["plus",{"sourceInterval":[1119,1125]},["app",{"sourceInterval":[1119,1124]},"space",[]]],["param",{},0],["plus",{"sourceInterval":[1128,1134]},["app",{"sourceInterval":[1128,1133]},"space",[]]]]],"parented":["define",{"sourceInterval":[1139,1176]},null,["x"],["seq",{"sourceInterval":[1153,1176]},["terminal",{"sourceInterval":[1153,1156]},"("],["star",{"sourceInterval":[1157,1163]},["app",{"sourceInterval":[1157,1162]},"space",[]]],["param",{},0],["star",{"sourceInterval":[1166,1172]},["app",{"sourceInterval":[1166,1171]},"space",[]]],["terminal",{"sourceInterval":[1173,1176]},")"]]],"spacedBool":["define",{"sourceInterval":[1182,1215]},null,[],["app",{"sourceInterval":[1195,1215]},"spaced",[["app",{"sourceInterval":[1202,1214]},"boolOperator",[]]]]],"genericBoolOp":["define",{"sourceInterval":[1220,1265]},null,[],["alt",{"sourceInterval":[1236,1265]},["app",{"sourceInterval":[1236,1246]},"spacedBool",[]],["app",{"sourceInterval":[1249,1256]},"orSpace",[]],["app",{"sourceInterval":[1259,1265]},"orLine",[]]]],"fieldName":["define",{"sourceInterval":[1290,1341]},null,[],["seq",{"sourceInterval":[1302,1341]},["not",{"sourceInterval":[1302,1315]},["app",{"sourceInterval":[1303,1315]},"reservedWord",[]]],["plus",{"sourceInterval":[1316,1336]},["alt",{"sourceInterval":[1317,1334]},["app",{"sourceInterval":[1317,1322]},"alnum",[]],["terminal",{"sourceInterval":[1325,1328]},"."],["terminal",{"sourceInterval":[1331,1334]},"_"]]],["lookahead",{"sourceInterval":[1337,1341]},["terminal",{"sourceInterval":[1338,1341]},":"]]]],"fieldCond":["define",{"sourceInterval":[1346,1380]},null,[],["seq",{"sourceInterval":[1358,1380]},["app",{"sourceInterval":[1358,1367]},"fieldName",[]],["terminal",{"sourceInterval":[1368,1371]},":"],["app",{"sourceInterval":[1372,1380]},"subquery",[]]]],"rangeValue":["define",{"sourceInterval":[1405,1465]},null,[],["seq",{"sourceInterval":[1418,1465]},["not",{"sourceInterval":[1418,1424]},["app",{"sourceInterval":[1419,1424]},"space",[]]],["alt",{"sourceInterval":[1426,1464]},["plus",{"sourceInterval":[1426,1458]},["alt",{"sourceInterval":[1427,1456]},["app",{"sourceInterval":[1427,1432]},"alnum",[]],["terminal",{"sourceInterval":[1435,1438]},"/"],["terminal",{"sourceInterval":[1441,1444]},"-"],["terminal",{"sourceInterval":[1447,1450]},":"],["terminal",{"sourceInterval":[1453,1456]},"+"]]],["terminal",{"sourceInterval":[1461,1464]},"*"]]]],"rangeCond":["define",{"sourceInterval":[1470,1538]},null,[],["seq",{"sourceInterval":[1482,1538]},["terminal",{"sourceInterval":[1482,1485]},"["],["star",{"sourceInterval":[1486,1492]},["app",{"sourceInterval":[1486,1491]},"space",[]]],["app",{"sourceInterval":[1493,1503]},"rangeValue",[]],["app",{"sourceInterval":[1504,1516]},"spaced",[["terminal",{"sourceInterval":[1511,1515]},"TO"]]],["app",{"sourceInterval":[1517,1527]},"rangeValue",[]],["star",{"sourceInterval":[1528,1534]},["app",{"sourceInterval":[1528,1533]},"space",[]]],["terminal",{"sourceInterval":[1535,1538]},"]"]]],"regexCond":["define",{"sourceInterval":[1563,1608]},null,[],["seq",{"sourceInterval":[1575,1608]},["terminal",{"sourceInterval":[1575,1578]},"/"],["plus",{"sourceInterval":[1579,1604]},["alt",{"sourceInterval":[1580,1602]},["app",{"sourceInterval":[1580,1585]},"alnum",[]],["app",{"sourceInterval":[1588,1602]},"regexCharacter",[]]]],["terminal",{"sourceInterval":[1605,1608]},"/"]]],"genericCond":["define",{"sourceInterval":[1632,1694]},null,[],["alt",{"sourceInterval":[1646,1694]},["app",{"sourceInterval":[1646,1655]},"fieldCond",[]],["app",{"sourceInterval":[1658,1667]},"rangeCond",[]],["app",{"sourceInterval":[1670,1679]},"regexCond",[]],["app",{"sourceInterval":[1682,1694]},"detachedCond",[]]]],"cond":["define",{"sourceInterval":[1699,1741]},null,[],["alt",{"sourceInterval":[1706,1741]},["app",{"sourceInterval":[1706,1727]},"parented",[["app",{"sourceInterval":[1715,1726]},"genericCond",[]]]],["app",{"sourceInterval":[1730,1741]},"genericCond",[]]]],"simpleNegation":["define",{"sourceInterval":[1747,1776]},null,[],["seq",{"sourceInterval":[1764,1776]},["terminal",{"sourceInterval":[1764,1767]},"-"],["app",{"sourceInterval":[1768,1776]},"subquery",[]]]],"simpleMust":["define",{"sourceInterval":[1781,1806]},null,[],["seq",{"sourceInterval":[1794,1806]},["terminal",{"sourceInterval":[1794,1797]},"+"],["app",{"sourceInterval":[1798,1806]},"subquery",[]]]],"longNegation":["define",{"sourceInterval":[1811,1847]},null,[],["seq",{"sourceInterval":[1826,1847]},["terminal",{"sourceInterval":[1826,1831]},"NOT"],["plus",{"sourceInterval":[1832,1838]},["app",{"sourceInterval":[1832,1837]},"space",[]]],["app",{"sourceInterval":[1839,1847]},"subquery",[]]]],"markedCond":["define",{"sourceInterval":[1852,1907]},null,[],["alt",{"sourceInterval":[1865,1907]},["app",{"sourceInterval":[1865,1877]},"longNegation",[]],["app",{"sourceInterval":[1880,1894]},"simpleNegation",[]],["app",{"sourceInterval":[1897,1907]},"simpleMust",[]]]],"queryElement":["define",{"sourceInterval":[1913,1945]},null,[],["alt",{"sourceInterval":[1928,1945]},["app",{"sourceInterval":[1928,1938]},"markedCond",[]],["app",{"sourceInterval":[1941,1945]},"cond",[]]]],"subquery":["define",{"sourceInterval":[1947,1988]},null,[],["alt",{"sourceInterval":[1958,1988]},["app",{"sourceInterval":[1958,1973]},"parented",[["app",{"sourceInterval":[1967,1972]},"query",[]]]],["app",{"sourceInterval":[1976,1988]},"queryElement",[]]]],"query":["define",{"sourceInterval":[1993,2058]},null,[],["alt",{"sourceInterval":[2001,2058]},["app",{"sourceInterval":[2001,2040]},"nonemptyListOf",[["app",{"sourceInterval":[2016,2024]},"subquery",[]],["app",{"sourceInterval":[2026,2039]},"genericBoolOp",[]]]],["app",{"sourceInterval":[2043,2058]},"parented",[["app",{"sourceInterval":[2052,2057]},"query",[]]]]]]}]);
